package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.KeyPageOperation;
import io.accumulatenetwork.sdk.protocol.TransactionBody;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: TransactionType
// UnionValue: UpdateKeyPage

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("UpdateKeyPage")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UpdateKeyPage implements TransactionBody {
	public final TransactionType type = TransactionType.UPDATE_KEY_PAGE;
	private KeyPageOperation[] operation;

    //
	public KeyPageOperation[] getOperation() {
	    return operation;
	}
	public void setOperation(final KeyPageOperation[] value) {
	    this.operation = value;
	}

	public UpdateKeyPage operation(final KeyPageOperation[] value) {
	    setOperation(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.operation == null)) {
            marshaller.writeValue(2, operation);
        }
        return marshaller.array();
    }
}
